Subject: Re: bug#50975: 28.0.60; mh-utils-tests fail with native compilation

From: Stephen Gildea <[email-masked]>
Date: Mon, 04 Oct 2021 17:29:02 -0700

Thank you, Andrea, for the native-trampolines patch to mh-utils-tests.el.
In this patch, the test explicitly compiles trampolines before redefining
two functions that are defined in C.

Is it necessary to provide trampolines at all for these short-lived test
functions?  The following works for me:

    (mapc (lambda (x) (add-to-list 'native-comp-never-optimize-functions x))
          '(call-process file-directory-p))

Before redefining the functions, the test could create a dynamic local
binding for native-comp-never-optimize-functions and add to it as above.

If that is a reasonable approach, can we go further?  Can the
native-compile code detect that this is a test and automatically
suppress trying to compile a trampoline, without the test having
to be aware of native-compile?

 < Stephen